local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local c = BittensSpellFlashLibrary

local GetPowerRegen = GetPowerRegen
local select = select

a.Rotations = {}
c.RegisterForEvents(a)
a.SetSpamFunction(function()
	c.Flash(a)
end)

------------------------------------------------------------------------- 4pT13
a.StolenTimeRemaining = 10

local function auraApplied4pT13(spellID, cooldown)
	if not c.WearingSet(4, "T13") then
		a.StolenTimeRemaining = 0
	elseif spellID == c.GetID(cooldown) then
		a.StolenTimeRemaining = 10
		c.Debug("Event", "Stolen Time will reset", a.StolenTimeRemaining)
	elseif spellID == c.GetID("Stolen Time")
		and a.StolenTimeRemaining > 0
		and not s.Buff(c.GetID(cooldown), "player") then
			
		a.StolenTimeRemaining = a.StolenTimeRemaining - 1
		c.Debug("Event", "Stolen Time bump", a.StolenTimeRemaining)
	end
end

local function auraRemoved4pT13(spellID, cooldown)
	if spellID == c.GetID("Stolen Time") then
		a.StolenTimeRemaining = 10
		c.Debug("Event", "Stolen Time reset", 10)
	end
end

------------------------------------------------------------------------ Arcane
--local function setBlastColor(color)
--	c.GetSpell("Arcane Blast").FlashColor = color
--end
--
--local function flashBlast(color)
--	setBlastColor(color)
--	a.Flash("Arcane Blast")
--end
--
--local function flashNeutralAround(percent, manaRatio, warningRatio)
--	if warningRatio and manaRatio >= warningRatio then
--		setBlastColor("red")
--	else
--		setBlastColor(nil)
--	end
--	if manaRatio > percent / 100 then
--		a.FlashAll("Arcane Blast", "Conjure Mana Gem")
--	else
--		a.Flash("Arcane Missiles", "Arcane Blast")
--	end
--end

a.Rotations.Arcane = {
	Spec = 1,
	OffSwitch = "arcane_off",
	
	FlashInCombat = function()
		if c.IsCasting("Arcane Barrage") then
			a.ChargeStacks = 0
		else
			a.ChargeStacks = s.DebuffStack(c.GetID("Arcane Charge"), "player")
			if a.ChargeStacks < 6 and (
				c.IsCasting("Arcane Blast")
					or c.IsCasting("Arcane Missiles")) then
				
				a.ChargeStacks = a.ChargeStacks + 1
			end
		end
		
		------------------------------------------------- mana calculations
		local mana = c.GetPower(select(2, GetPowerRegen()))
		a.ManaPercent = mana / s.MaxPower("player") * 100
		
		---------------------------------------------------------- flashing
		c.FlashAll("Counterspell", "Spellsteal")
--c.Debug("Flash", a.ChargeStacks, string.format("%.1f", a.ManaPercent),
		c.PriorityFlash(
			"Nether Tempest",
			"Frost Bomb",
			"Living Bomb",
			"Mirror Image",
			"Evocation",
			"Mana Gem",
			"Brilliant Mana Gem",
			"Arcane Power",
			"Presence of Mind",
			"Arcane Blast at Cap",
			"Arcane Missiles",
			"Arcane Barrage",
			"Arcane Blast")
--)
	end,
	
	FlashOutOfCombat = function()
		c.FlashAll("Conjure Mana Gem")
	end,
	
	FlashAlways = function()
		c.FlashAll(
			"Mage Armor",
			"Arcane Brilliance",
			"Dalaran Brilliance")
	end,
	
	AuraApplied = function(spellID)
		auraApplied4pT13(spellID, "Arcane Power")
	end,
	
	AuraRemoved = function(spellID)
		auraRemoved4pT13(spellID, "Arcane Power")
	end, 
}
